//
// μưбդ(ver.1.3)
//	ʿ14ǯ615

// «ɾ

#include <iostream>
#include <cmath>

using namespace std;

#include "Mat.h"
#include "Corresp_cls.h"
#include "homography.h"
#include "fundamental.h"
#include "eval_cnstr.h"

// ٥ȥΥԡ
static void
copy_vecs(CrpPair cp[], int N, int N1,
	  VecC Xa0[], VecC Xb0[], VecC Xa[], VecC Xb[], double p[])
{
   int	j;

   // ԡ
   j = 0;
   for (int i = 1; i <= N; i++)
   {
      if (cp[i].flag)
      {
	 Xa[j] = Xa0[cp[i].a];
	 Xb[j] = Xb0[cp[i].b];
	 p[j] = cp[i].Plmd;
	 if (++j > N1)
	 {
	    cerr << "copy vec: error" << endl;
	    break;
	 }
      }
   }
}

// ͱѴФĺ J_{\lambda} η׻
double
calc_J_lambda_homo(Mat& H, VecC& Xa, VecC& Xb, int aprxflg)
{
   double	D;
   VecC		t, HXa, XbHXa;
   Mat		XbH, W, T;
   Mat		Pk(1.0, 0.0, 0.0,
		   0.0, 1.0, 0.0,
		   0.0, 0.0, 0.0);

   if (aprxflg)
   {
      t = Xb - Znorm(H * Xa);
      D = (t,t);
   }
   else
   {
      XbH = Xb % H;
      HXa = H * Xa;
      T = XbH * Pk * (~XbH) + HXa % Pk % HXa;
      W = trc_gen_inv(T, 2);
      XbHXa = Xb % (H * Xa);
      D = (XbHXa, (W * XbHXa));
   }

   return D;
}

// ͱѴη׻Ȥɾ
void
eval_constraint_H(CrpPair cp[], int N, int N1,
		  VecC Xa0[], int Na, VecC Xb0[], int Nb, Mat& H)
{
   VecC		Xa[Na], Xb[Nb];
   double	pp[N];
   int		cnt;
   double	epsh;

   // ɬפʤΤΤߥԡ
   copy_vecs(cp, N, N1, Xa0, Xb0, Xa, Xb, pp);

   // ͱѴη׻
   calc_homography(Xa, Xb, pp, N1, H, 2, 1e-10, 30, &epsh, &cnt);

   for (int i = 1; i <= N; i++)
      cp[i].Dlmd = calc_J_lambda_homo(H, Xa0[cp[i].a], Xb0[cp[i].b]);
}

// J_{\lambda}η׻
double
calc_J_lambda_fund(Mat& F, VecC& Xa, VecC& Xb)
{
   Mat		Pk(1.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0);
   VecC		Ta, Tb;
   double	J, d;

   Ta = Pk * (~F) * Xa;
   Tb = Pk * F * Xb;
   d = Ta.sqnorm() + Tb.sqnorm();
   J = (Xa , (F * Xb));

   return J * J / d;
}

// ùη׻Ȥɾ
void
eval_constraint_F(CrpPair cp[], int N, int N1,
		  VecC Xa0[], int Na, VecC Xb0[], int Nb, Mat& F)
{
   VecC		Xa[Na], Xb[Nb];
   double	pp[N];

   // ɬפʤΤΤߥԡ
   copy_vecs(cp, N, N1, Xa0, Xb0, Xa, Xb, pp);

   cerr << "[[ fundamental matrix fitting ]]" << endl;
   // ùη׻
   calc_fundamental(Xa, Xb, pp, N1, F, 2, 1e-10, 30);

   for (int i = 1; i <= N; i++)
      cp[i].Dlmd = calc_J_lambda_fund(F, Xa0[cp[i].a], Xb0[cp[i].b]);
}
