//
// ùη׻
//

#include <iostream>

using namespace std;

#include "Tensor.h"
#include "fundamental.h"

//
// FȤʬƥ󥽥V_0FͿơ
// FdetF=0Ȥʤ褦˺Ŭ
//
static int
correct_to_det_zero(Mat& F, Tensor3333& V_0F, double eps_d, Mat& co_F)
{
   int		i, j, k, l, m, n, p, q, iter = 0;
   Mat		F_trs, T_prd;
   Tensor3333	P, v0fp, v0f = V_0F;

   co_F = F;
   while (fabs(det33(co_F)) > eps_d)
   {
      iter++;
      if (iter > 20)
      {
//	 cerr <<  "Iteration exceeded 20 times." << endl;
	 return FAILED;
      }

      // co_F򹹿
      F_trs = ~(cofactor33(co_F));
      T_prd = v0f * F_trs;
      co_F = normalize(co_F - det33(co_F) * T_prd / (F_trs, T_prd));

      // co_Fμͱƥƥ󥽥P׻
      P = projection(co_F);

      //ưǧѤν
      //printf("PF = \n");
      //(P*co_F).Print();
      //printf("\n");
      //0ˤʤ뤳ȤǧѤ

      //co_Fʬƥ󥽥v0f򹹿
      v0fp = v0f;	// ͤ򥳥ԡ
      for (i = 0; i < 3; i++)
	for (j = 0; j < 3; j++)
	  for (k = 0; k < 3; k++)
	    for (l = 0; l < 3; l++)
	      for (m = 0; m < 3; m++)
		for (n = 0; n < 3; n++)
		  for (p = 0; p < 3; p++)
		    for (q = 0; q < 3; q++)
		      {
			v0f(i,j,k,l)
			  += P(i,j,m,n) * P(k,l,p,q) * v0fp(m,n,p,q);
		      }
      
      //ưǧѤν
      //printf("V[F]F = \n");
      //(v0f*co_F).Print(); //v0f*co_F3333ƥ󥽥33(=33)
    }

  return SUCCEEDED;
}

//
// 3333ƥ󥽥M_hat9ĤθͭVectorN(9)бͭ
// ľMatrix*, ڤΥ٥οe_hat2Ϳơ
// ùF, ɸаF_plus, F_minus֤
//  (PDP = primary deviation pair)
//
static int
prim_dev_pair(Mat Eg_mat[], VecC& Eg_val, int N,
	      double e_hat2, Mat& F, Mat& Fp, Mat& Fm, int crr_flag)
{
   int		i, j, k, l, m, n, p, q;
   Tensor3333	M_hat, V_0F, W, Pi;
   Mat		F0;

   // M_hatκǾͭͤбͭFȤ
   F0 = Eg_mat[8]; 

   // Fʬƥ󥽥V_0F׻
   V_0F.clear(0.0);
   for (int a = 0; a < 8; a++)
      V_0F += tensor_product(Eg_mat[a], Eg_mat[a]) / Eg_val[a];
   V_0F /= (double)N;
  
   // FdetF=0Ȥʤ褦
   if (crr_flag == 1)
      if (correct_to_det_zero(F0, V_0F, 1.0e-12, F) == FAILED)
	 return FAILED;

   // ⡼ȥƥ󥽥M_hat׻ľ
   M_hat.clear();
   for (int a = 0; a < 8; a++)
      M_hat += Eg_val[a] * tensor_product(Eg_mat[a], Eg_mat[a]);

   // ƥ󥽥W׻
   Pi = pseudo_projection(cofactor33(F));
   for (i = 0; i < 3; i++)
      for (j = 0; j < 3; j++)
	 for (k = 0; k < 3; k++)
	    for (l = 0; l < 3; l++)
	       for (m = 0; m < 3; m++)
		  for (n = 0; n < 3; n++)
		     for (p = 0; p < 3; p++)
			for (q = 0; q < 3; q++)
			{
			   W(i,j,k,l) = W(i,j,k,l) +
			      Pi(i,j,m,n) * Pi(k,l,p,q) * M_hat(m,n,p,q);
			}
  

   // ƥ󥽥W9Ĥθͭͭ͡
   VecC		Eg_mu(9);
   Mat		Eg_G[9];

   if (Eigen3333(W, Eg_mu, Eg_G))
   {
      //ɸаF_plus, F_minus׻
      double	mu = sqrt(e_hat2/(Eg_mu[6] * N));
      Fp = normalize(F + mu * Eg_G[6]);
      Fm = normalize(F - mu * Eg_G[6]);
   }
   else
   {
      cerr << "Cannot calculate eigenvalues of Tensor 'W'" << endl;
      return FAILED;
   }
   return SUCCEEDED;
}

//
// ƥƥ󥽥η׻
//
inline void
set_tensors(Tensor3333& M, Tensor3333& N1, Tensor3333& N2,
	    VecC& x1, VecC& x2, Mat& V1, Mat& V2,
	    double W, int dim)
{
   for (int i = 0; i < 3; i++)
      for (int j = 0; j < 3; j++)
	 for (int k = 0; k < 3; k++)
	    for (int l = 0; l < 3; l++)
	    {
	       if (3*(i-1)+j <= 3*(k-1)+l)
	       {
		  M(i,j,k,l) += W*x1[i]*x2[j]*x1[k]*x2[l];
		  N1(i,j, k,l) +=
		     W*(V1[i][k]*x2[j]*x2[l] + V2[j][l]*x1[i]*x1[k]);
		  if (dim == 2)
		     N2(i,j,k,l) += W*V1[i][k]*V2[j][l];
	       }
	    }
}

// ꤳˡˤù׻(ΨŤդ)
int
renorm_fund(VecC* x01, VecC* x02, double p[], int Num,
	    VecC& Eg_val, Mat* Eg_mat, double* J0,
	    int dim, double m_eps, int itmax)
//  x01:	array of image points(camera1).         input
//  x02:	array of image points(camera2).         input
//  V01:	array of covariance matrices for x01.   input
//  V02:	array of covariance matrices for x02.   input
//  Num:	number of image points.                 input
//  Eg_val:	eigenvalues of the moment tensor.       output
//  Eg_mat:	eigenmatrices of the moment tensor.     output
//  J:		residual of the renormalization.	output
//  dim:	order of the renormalization.		input
//  m_eps:	value for convergence test.		input
//  itmax:	maximum iteration count.		input
//
//Return value
//  iteration number
{
   int		a, iter;
   double	lambda9, W, c, J, J2;
   double	inp1, inp2, D, tmpw;
   VecC		x1, x2;
   Mat		F9, TF9;
   Tensor3333	M_hat, M, N1, N2;
   Mat		Pk(1.0, 0.0, 0.0,
		   0.0, 1.0, 0.0,
		   0.0, 0.0, 0.0);
   Mat		V1, V2;

   // ƥ󥽥ȻĺJ
   M.clear(0.0);
   N1.clear(0.0);
   if (dim == 2)  N2.clear(0.0);
   *J0 = J = 1.0e10;

   W = 1.0;
   // ƥƥ󥽥Ǥ׻
   for (a = 0; a < Num; a++)
   {    
      // ֤٥ȥȶʬ
      x1 = x01[a];
      x2 = x02[a];
      V1 = V2 = Pk / p[a];
      // ƥƥ󥽥Ƿ׻
      set_tensors(M, N1, N2, x1, x2, V1, V2, W, dim);
   }


   // ƥƥ󥽥λĤǤ򤹤٤
   M.fill();
   N1.fill();
   if (dim == 2) N2.fill();

   // ƥƥ󥽥򹹿
   M /= (double)Num;
   N1 /= (double)Num;
   if (dim == 2) 
      N2 /= (double)Num;
   M_hat = M;

   // M_hat9Ĥθͭͭ͡
   if (!Eigen3333(M_hat, Eg_val, Eg_mat))
      return FAILED;
   else
   {
      lambda9 = Eg_val[8]; //Ǿͭ
      if (lambda9 < 0.0) lambda9 = -lambda9;
      F9 = Eg_mat[8];      //бΥ1θͭ
   }

   // ꤳˡȿ
   iter = 0;
   c = 0.0;
   do 
   {
      iter++; // ȿ++

      // ȿitmaxۤ齪λ(ꤳˡ)
      if (iter > itmax)
      {
//           printf("Renormalization exceed %d iteration.\n", itmax);
	 return FAILED;
      }

      // cι
      inp1 = (F9, (N1*F9)); // F9N1*F9
      inp2 = (F9, (N2*F9)); // F9N2*F9

      if (dim == 2) 
      {
	 D = pow(inp1 - 2.0*c*inp2, 2) - 4.0*lambda9*inp2;
	 if (D >= 0.0)
	    c += (inp1 - 2.0*c*inp2 - sqrt(D))/(2.0*inp2);
	 else
	    c += lambda9/inp1;
      }
      else 
	 c = c + lambda9/inp1;

      // ƥƥ󥽥ν
      M.clear();
      N1.clear();
      if (dim == 2) 
	 N2.clear();

      // ƥƥ󥽥Ǥ׻
      for (a = 0; a < Num; a++)
      {
	 // ֤٥ȥȶʬ
	 x1 = x01[a];
	 x2 = x02[a];
	 // ŤWι
	 TF9 = (~F9);
	 tmpw = (x2, TF9*V1*F9*x2) + (x1, F9*V2*TF9*x1);
	 if (dim == 2)
	    tmpw += c*(V1*F9, F9*V2);
	 W = 1.0/tmpw;
	  
	 // ƥƥ󥽥Ƿ׻
	 set_tensors(M, N1, N2, x1, x2, V1, V2, W, dim);
      }
          
      // ƥƥ󥽥λĤǤ򤹤٤
      M.fill();
      N1.fill();
      if (dim == 2) N2.fill();

      // ƥƥ󥽥ι
      M /= (double)(Num);
      N1 /= (double)(Num);
      M_hat = M - c * N1;
      if (dim == 2)
      {
	 N2 /= (double)(Num);
	 M_hat += c*c*N2;
      }

      // ĺJ򹹿
      J2 = J;
      J = (F9, (M*F9));
      
      if (J2 < J)
	 J = J2;
      else
      {
	 // M_hat9Ĥθͭͭ͡
	 
	 if (!Eigen3333(M_hat, Eg_val, Eg_mat))
	    return FAILED;
	 else
	 {
	    lambda9 = Eg_val[8]; //Ǿͭ
	    F9 = Eg_mat[8];      //бΥ1θͭ
	 }
      }
   }
   while ((J2 > J) && ((fabs(lambda9)) > m_eps));

   *J0 = J;
   return SUCCEEDED;
}


// ꤳˡˤù׻
int
renorm_fund(VecC* x01, VecC* x02, int Num,
	    VecC& Eg_val, Mat* Eg_mat, double* J0,
	    int dim, double m_eps, int itmax)
//  x01:	array of image points(camera1).         input
//  x02:	array of image points(camera2).         input
//  V01:	array of covariance matrices for x01.   input
//  V02:	array of covariance matrices for x02.   input
//  Num:	number of image points.                 input
//  Eg_val:	eigenvalues of the moment tensor.       output
//  Eg_mat:	eigenmatrices of the moment tensor.     output
//  J:		residual of the renormalization.	output
//  dim:	order of the renormalization.		input
//  m_eps:	value for convergence test.		input
//  itmax:	maximum iteration count.		input
//
//Return value
//  iteration number
{
   int		a, iter;
   double	lambda9, W, c, J, J2;
   double	inp1, inp2, D, tmpw;
   VecC		x1, x2;
   Mat		F9, TF9;
   Tensor3333	M_hat, M, N1, N2;
   Mat		Pk(1.0, 0.0, 0.0,
		   0.0, 1.0, 0.0,
		   0.0, 0.0, 0.0);
   Mat		V1, V2;

   // ʬΥå
   V1 = V2 = Pk;

   // ƥ󥽥ȻĺJ
   M.clear(0.0);
   N1.clear(0.0);
   if (dim == 2)  N2.clear(0.0);
   *J0 = J = 1.0e10;

   W = 1.0;
   // ƥƥ󥽥Ǥ׻
   for (a = 0; a < Num; a++)
   {    
      // ֤٥ȥȶʬ
      x1 = x01[a];
      x2 = x02[a];
      // ƥƥ󥽥Ƿ׻
      set_tensors(M, N1, N2, x1, x2, V1, V2, W, dim);
   }


   // ƥƥ󥽥λĤǤ򤹤٤
   M.fill();
   N1.fill();
   if (dim == 2) N2.fill();

   // ƥƥ󥽥򹹿
   M /= (double)Num;
   N1 /= (double)Num;
   if (dim == 2) 
      N2 /= (double)Num;
   M_hat = M;

   // M_hat9Ĥθͭͭ͡
   if (!Eigen3333(M_hat, Eg_val, Eg_mat))
      return FAILED;
   else
   {
      lambda9 = Eg_val[8]; //Ǿͭ
      if (lambda9 < 0.0) lambda9 = -lambda9;
      F9 = Eg_mat[8];      //бΥ1θͭ
   }

   // ꤳˡȿ
   iter = 0;
   c = 0.0;
   do 
   {
      iter++; // ȿ++

      // ȿitmaxۤ齪λ(ꤳˡ)
      if (iter > itmax)
      {
//           printf("Renormalization exceed %d iteration.\n", itmax);
	 return FAILED;
      }

      // cι
      inp1 = (F9, (N1*F9)); // F9N1*F9
      inp2 = (F9, (N2*F9)); // F9N2*F9

      if (dim == 2) 
      {
	 D = pow(inp1 - 2.0*c*inp2, 2) - 4.0*lambda9*inp2;
	 if (D >= 0.0)
	    c += (inp1 - 2.0*c*inp2 - sqrt(D))/(2.0*inp2);
	 else
	    c += lambda9/inp1;
      }
      else 
	 c = c + lambda9/inp1;

      // ƥƥ󥽥ν
      M.clear();
      N1.clear();
      if (dim == 2) 
	 N2.clear();

      // ƥƥ󥽥Ǥ׻
      for (a = 0; a < Num; a++)
      {
	 // ֤٥ȥȶʬ
	 x1 = x01[a];
	 x2 = x02[a];
	 // ŤWι
	 TF9 = (~F9);
	 tmpw = (x2, TF9*V1*F9*x2) + (x1, F9*V2*TF9*x1);
	 if (dim == 2)
	    tmpw += c*(V1*F9, F9*V2);
	 W = 1.0/tmpw;
	  
	 // ƥƥ󥽥Ƿ׻
	 set_tensors(M, N1, N2, x1, x2, V1, V2, W, dim);
      }
          
      // ƥƥ󥽥λĤǤ򤹤٤
      M.fill();
      N1.fill();
      if (dim == 2) N2.fill();

      // ƥƥ󥽥ι
      M /= (double)(Num);
      N1 /= (double)(Num);
      M_hat = M - c * N1;
      if (dim == 2)
      {
	 N2 /= (double)(Num);
	 M_hat += c*c*N2;
      }

      // ĺJ򹹿
      J2 = J;
      J = (F9, (M*F9));
      
      if (J2 < J)
	 J = J2;
      else
      {
	 // M_hat9Ĥθͭͭ͡
	 
	 if (!Eigen3333(M_hat, Eg_val, Eg_mat))
	    return FAILED;
	 else
	 {
	    lambda9 = Eg_val[8]; //Ǿͭ
	    F9 = Eg_mat[8];      //бΥ1θͭ
	 }
      }
   }
   while ((J2 > J) && ((fabs(lambda9)) > m_eps));

   *J0 = J;
   return SUCCEEDED;
}


// Ǿˡˤù׻
int
ls_fund(VecC *x01, VecC *x02, int Num, VecC& Eg_val, Mat *Eg_mat)
//  x01:	array of image points(camera1).         input
//  x02:	array of image points(camera2).         input
//  Num:	number of image points.                 input
//  Eg_val:	eigenvalues of the moment tensor.       output
//  Eg_mat:	eigenmatrices of the moment tensor.     output
//
//Return value
//  iteration number
{
   int		i, j, k, l, a;
   double	lambda9;
   VecC		x1, x2;
   Mat		F9;
   Tensor3333	M_hat, M;


   // ƥ󥽥
   M.clear(0.0);

   // ƥƥ󥽥Ǥ׻
   for (a = 0; a < Num; a++)
   {    
      // ֤٥ȥȶʬ
      x1 = x01[a];
      x2 = x02[a];

      //ƥƥ󥽥Ƿ׻
      for (i = 0; i < 3; i++)
	 for (j = 0; j < 3; j++)
	    for (k = 0; k < 3; k++)
	       for (l = 0; l < 3; l++)
	       {
		  if (3*(i-1)+j <= 3*(k-1)+l)
		  {
		    M(i,j,k,l) += x1[i]*x2[j]*x1[k]*x2[l];
		  }
	       }
   }


   // ƥƥ󥽥λĤǤ򤹤٤
   M.fill();


   // ƥƥ󥽥򹹿
   M /= (double)Num;
   M_hat = M;
  
   // M_hat  9 Ĥθͭͭ͡
   if (!Eigen3333(M_hat, Eg_val, Eg_mat))
      return FAILED;
   else
   {
      lambda9 = Eg_val[8]; //Ǿͭ
      if (lambda9 < 0.0) lambda9 = -lambda9;
      F9 = Eg_mat[8];      //бΥ1θͭ
   }
   return SUCCEEDED;
}

// ꤳˡˤù׻(Ψ̵)
int
calc_fundamental(VecC* x01, VecC* x02, int Num,
		 Mat& F, int dim, double m_eps, int itmax)
{
   double	J, e_hat2;
   Mat		Eg_mat[9];
   Mat		Fp, Fm;
   VecC		Eg_val(9);
   int		ret;

   ret = renorm_fund(x01, x02, Num, Eg_val, Eg_mat, &J,
		     dim, m_eps, itmax);

   if (ret == SUCCEEDED)
   {
      // ùಽȽ
      J = fabs(J);
      e_hat2 = J/(1.0 - 8/(double)Num);
      if (e_hat2 > Eg_val[7] * Num)
      {
	 cerr << "calc_fundamental(): warning! Degeneracy! ["
	      << e_hat2 << " > "
	      << Eg_val[7] * Num << "]" << endl;
	 (void)prim_dev_pair(Eg_mat, Eg_val, Num, e_hat2, F, Fp, Fm, 1);
	 return FAILED;
      }
      else
      {
	 // Ŭڤɸа̷׻Ԥ
	 return prim_dev_pair(Eg_mat, Eg_val, Num, e_hat2, F, Fp, Fm, 1);
      }
   }
   else
      cerr << "Renormalization: failure.\n" << endl;

   return FAILED;
}

// ꤳˡˤù׻(Ψ)
int
calc_fundamental(VecC* x01, VecC* x02, double p[], int Num,
		 Mat& F, int dim, double m_eps, int itmax)
{
   double	J, e_hat2;
   Mat		Eg_mat[9];
   Mat		Fp, Fm;
   VecC		Eg_val(9);
   int		ret;

   ret = renorm_fund(x01, x02, p, Num, Eg_val, Eg_mat, &J,
		     dim, m_eps, itmax);

   if (ret == SUCCEEDED)
   {
      // ùಽȽ
      J = fabs(J);
      e_hat2 = J/(1.0 - 8/(double)Num);
      if (e_hat2 > Eg_val[7] * Num)
      {
	 cerr << "calc_fundamental(): warning! Degeneracy! ["
	      << e_hat2 << " > "
	      << Eg_val[7] * Num << "]" << endl;
	 (void)prim_dev_pair(Eg_mat, Eg_val, Num, e_hat2, F, Fp, Fm, 1);
	 return FAILED;
      }
      else
      {
	 // Ŭڤɸа̷׻Ԥ
	 return prim_dev_pair(Eg_mat, Eg_val, Num, e_hat2, F, Fp, Fm, 1);
      }
   }
   else
      cerr << "Renormalization: failure.\n" << endl;

   return FAILED;
}

// Ǿˡˤù׻
int
calc_fundamental_ls(VecC* x01, VecC* x02, int Num, Mat& F)
{
   double	e_hat2 = 0.0;
   Mat		Eg_mat[9];
   Mat		Fp, Fm;
   VecC		Eg_val(9);
   int		ret;

   ret = ls_fund(x01, x02, Num, Eg_val, Eg_mat);
   if (ret == SUCCEEDED)
   {
      return prim_dev_pair(Eg_mat, Eg_val, Num, e_hat2, F, Fp, Fm, 1);
   }
   else
      cerr << "Least squares: failure." << endl;

   return FAILED;
}
