#ifndef	_CIMAGE_H_
#define	_CIMAGE_H_

// #define      NODEBUG

#include        <cassert>
#include        <cstdlib>

#include	"Image.h"

// ǥեȤΥ

#define	WIDTH	640
#define	HEIGHT	480

#define	TEMPLATESIZE	7	// 15 x 15 Υƥץ졼
#define	MASK_SIZE	3	// 3 x 3 Υޥ

class	CImage
{
  private:
        int	*r, *g, *b;
        int	xlength, ylength;
        int     xc, yc;

  public:
        CImage(int xs = WIDTH, int ys = HEIGHT);
        CImage(int xmin, int ymin, int xmax, int ymax);
        ~CImage();
        void    set_size(int xs, int ys);
	void	set_size(int xmin, int ymin, int xmax, int ymax);
        void    set_center(int xc, int yc);

	int	width() { return xlength; }
	int	height() { return ylength; }
        int     xl() { return xlength; }
        int     yl() { return ylength; }

        int     xcenter() { return xc; }
        int     ycenter() { return yc; }

        int     get_pixel_r(int x, int y);
        int     get_pixel_g(int x, int y);
        int     get_pixel_b(int x, int y);
        int     get_pixel2_r(int x, int y);
        int     get_pixel2_g(int x, int y);
        int     get_pixel2_b(int x, int y);
        double	get_cpixel_r(double x, double y);
        double	get_cpixel_g(double x, double y);
        double	get_cpixel_b(double x, double y);

        void    put_pixel_r(int x, int y, int d);
        void    put_pixel_g(int x, int y, int d);
        void    put_pixel_b(int x, int y, int d);

        void    plot_cross(int x, int y, int len = 5,
			   int r0 = 255, int g0 = 255, int b0 = 255);
        void    plot_im_cross(int x, int y, int len = 5,
			      int r0 = 255, int g0 = 255, int b0 = 255);

        int     get_pixel_r(int i) {return r[i];}
        int     get_pixel_g(int i) {return g[i];}
        int     get_pixel_b(int i) {return b[i];}

        void    put_pixel_r(int i, int d) {r[i] = d;}
        void    put_pixel_g(int i, int d) {g[i] = d;}
        void    put_pixel_b(int i, int d) {b[i] = d;}
                   
        int     get_im_pixel_r(int x, int y)
                {
		   assert(x >= 0 && x < xlength);
		   assert(y >= 0 && y < ylength);
                   return r[y * xlength + x];
                }
        int     get_im_pixel_g(int x, int y)
                {
		   assert(x >= 0 && x < xlength);
		   assert(y >= 0 && y < ylength);
                   return g[y * xlength + x];
                }
        int     get_im_pixel_b(int x, int y)
                {
		   assert(x >= 0 && x < xlength);
		   assert(y >= 0 && y < ylength);
                   return b[y * xlength + x];
                }
        void    put_im_pixel_r(int x, int y, int d)
                {
		   assert(x >= 0 && x < xlength);
		   assert(y >= 0 && y < ylength);
                   r[y * xlength + x] = d;
                }
        void    put_im_pixel_g(int x, int y, int d)
                {
		   assert(x >= 0 && x < xlength);
		   assert(y >= 0 && y < ylength);
                   g[y * xlength + x] = d;
                }
        void    put_im_pixel_b(int x, int y, int d)
                {
		   assert(x >= 0 && x < xlength);
		   assert(y >= 0 && y < ylength);
                   b[y * xlength + x] = d;
                }
        int     get_im_pixel2_r(int x, int y)
                {
		   if (   x >= 0 && x < xlength
		       && y >= 0 && y < ylength)
		      return r[y * xlength + x];
		   else
		      return -1;
                }
        int     get_im_pixel2_g(int x, int y)
                {
		   if (   x >= 0 && x < xlength
		       && y >= 0 && y < ylength)
		      return g[y * xlength + x];
		   else
		      return -1;
                }
        int     get_im_pixel2_b(int x, int y)
                {
		   if (   x >= 0 && x < xlength
		       && y >= 0 && y < ylength)
		      return b[y * xlength + x];
		   else
		      return -1;
                }
        void    put_im_pixel2_r(int x, int y, int d)
                {
		   if (   x >= 0 && x < xlength
		       && y >= 0 && y < ylength)
		      r[y * xlength + x] = d;
                }

        void    put_im_pixel2_g(int x, int y, int d)
                {
		   if (   x >= 0 && x < xlength
		       && y >= 0 && y < ylength)
		      g[y * xlength + x] = d;
                }

        void    put_im_pixel2_b(int x, int y, int d)
                {
		   if (   x >= 0 && x < xlength
		       && y >= 0 && y < ylength)
		      b[y * xlength + x] = d;
                }

        double	get_im_cpixel_r(double u, double v);
        double	get_im_cpixel_g(double u, double v);
        double	get_im_cpixel_b(double u, double v);

        void    clear(int data = 0);
        void    trim_size();

        friend void	display(CImage& img, char *title);

	friend void	copy_area(CImage& src, int u0, int v0,
				  int width, int height, CImage& dst);
        friend int	save_ppm_file(CImage& img, char *filename);
        friend int      load_ppm_file(CImage& img, char *filename);
        friend int	impose_ppm_file(CImage& img, char *filename);
        friend int      impose_ppm(CImage& im1, CImage &im2);

        friend void	CImagetoImage(CImage& cim, Image &im);
};

// ޥ
class	RealCMask
{
  private:
	double	*r, *g, *b;
	int	xh, yh;
	int	xs, ys;

  public:
	RealCMask(int xs0 = MASK_SIZE, int ys0 = MASK_SIZE)
	   {
	      assert(xs0 % 2 && ys0 % 2);
	      xs = xs0;
	      ys = ys0;
	      r = new double [xs * ys];
	      g = new double [xs * ys];
	      b = new double [xs * ys];
	      xh = xs / 2;
	      yh = ys / 2;
	   }
	~RealCMask()
	   {
	      delete [] r;
	      delete [] g;
	      delete [] b;
	   }

        int     xsize() { return xs; }
        int     ysize() { return ys; }

        double  get_mask_r(int x, int y)
                {
		   assert(abs(x) <= xh || abs(y) <= yh);
                   return r[(y + yh) * xs + (x + xh)];
                }
        double  get_mask_g(int x, int y)
                {
		   assert(abs(x) <= xh || abs(y) <= yh);
                   return g[(y + yh) * xs + (x + xh)];
                }
        double  get_mask_b(int x, int y)
                {
		   assert(abs(x) <= xh || abs(y) <= yh);
                   return b[(y + yh) * xs + (x + xh)];
                }
        void    put_mask_r(int x, int y, double d)
                {
		   assert(abs(x) <= xh || abs(y) <= yh);
                   r[(y + yh) * xs + (x + xh)] = d;
                }
        void    put_mask_g(int x, int y, double d)
                {
		   assert(abs(x) <= xh || abs(y) <= yh);
                   g[(y + yh) * xs + (x + xh)] = d;
                }
        void    put_mask_b(int x, int y, double d)
                {
		   assert(abs(x) <= xh || abs(y) <= yh);
                   b[(y + yh) * xs + (x + xh)] = d;
                }

        void    clear(double d = 0.0)
          	{
		   for (int i = 0; i < (xs * ys); i++)
		      r[i] = g[i] = b[i] = d;
		}
};

class	IntCMask
{
  private:
	int	*r, *g, *b;
	int	xh, yh;
	int	xs, ys;

  public:
	IntCMask(int xs0 = MASK_SIZE, int ys0 = MASK_SIZE)
	   {
	      assert(xs0 % 2 && ys0 % 2);
	      xs = xs0;
	      ys = ys0;
	      r = new int [xs * ys];
	      g = new int [xs * ys];
	      b = new int [xs * ys];
	      xh = xs / 2;
	      yh = ys / 2;
	   }
	~IntCMask()
	   {
	      delete [] r;
	      delete [] g;
	      delete [] b;
	   }

        int     xsize() { return xs; }
        int     ysize() { return ys; }

        int	get_mask_r(int x, int y)
                {
		   assert(abs(x) <= xh || abs(y) <= yh);
                   return r[(y + yh) * xs + (x + xh)];
                }
        int	get_mask_g(int x, int y)
                {
		   assert(abs(x) <= xh || abs(y) <= yh);
                   return g[(y + yh) * xs + (x + xh)];
                }
        int	get_mask_b(int x, int y)
                {
		   assert(abs(x) <= xh || abs(y) <= yh);
                   return b[(y + yh) * xs + (x + xh)];
                }
        void    put_mask_r(int x, int y, int d)
                {
		   assert(abs(x) <= xh || abs(y) <= yh);
                   r[(y + yh) * xs + (x + xh)] = d;
                }
        void    put_mask_g(int x, int y, int d)
                {
		   assert(abs(x) <= xh || abs(y) <= yh);
                   g[(y + yh) * xs + (x + xh)] = d;
                }
        void    put_mask_b(int x, int y, int d)
                {
		   assert(abs(x) <= xh || abs(y) <= yh);
                   b[(y + yh) * xs + (x + xh)] = d;
                }

        void    clear(int d = 0)
          	{
		   for (int i = 0; i < (xs * ys); i++)
		      r[i] = g[i] = b[i] = d;
		}
};

// ƥץ졼ȼ¿
class	RealCTemplate
{
  private:
	double	*r, *g, *b;
        int	x_size, y_size;
        int	xc, yc;
        int	x_min, x_max, y_min, y_max;

  public:
        RealCTemplate(int xs = TEMPLATESIZE, int ys = TEMPLATESIZE);
        ~RealCTemplate();

	void	resize(int nx, int ny);
        int     xl() { return x_size; }
        int     yl() { return y_size; }
        int     xl2() { return x_max; }
        int     yl2() { return y_max; }
        int     xmin() { return x_min; }
        int     xmax() { return x_max; }
        int     ymin() { return y_min; }
        int     ymax() { return y_max; }

        double  get_pixel_r(int x, int y);
        double  get_pixel_g(int x, int y);
        double  get_pixel_b(int x, int y);
        void    put_pixel_r(int x, int y, double d);
        void    put_pixel_g(int x, int y, double d);
        void    put_pixel_b(int x, int y, double d);

        double  get_im_pixel_r(int x, int y);
        double  get_im_pixel_g(int x, int y);
        double  get_im_pixel_b(int x, int y);
        void    put_im_pixel_r(int x, int y, double d);
        void    put_im_pixel_g(int x, int y, double d);
        void    put_im_pixel_b(int x, int y, double d);

        void    clear(double d = 0.0);
};


class	IntCTemplate
{
  private:
        int	*r, *g, *b;
        int	x_size, y_size;
        int	xc, yc;
        int	x_min, x_max, y_min, y_max;

  public:
        IntCTemplate(int xs = TEMPLATESIZE, int ys = TEMPLATESIZE);
        ~IntCTemplate();

	void	resize(int nx, int ny);
        int     xl() { return x_size; }
        int     yl() { return y_size; }
        int     xmin() { return x_min; }
        int     xmax() { return x_max; }
        int     ymin() { return y_min; }
        int     ymax() { return y_max; }

        int	get_pixel_r(int x, int y);
        int	get_pixel_g(int x, int y);
        int	get_pixel_b(int x, int y);
        void    put_pixel_r(int x, int y, int d);
        void    put_pixel_g(int x, int y, int d);
        void    put_pixel_b(int x, int y, int d);

        int	get_im_pixel_r(int u, int v);
        int	get_im_pixel_g(int u, int v);
        int	get_im_pixel_b(int u, int v);
        void    put_im_pixel_r(int u, int v, int d);
        void    put_im_pixel_g(int u, int v, int d);
        void    put_im_pixel_b(int u, int v, int d);

        void    clear(int d = 0.0);
};

void    wait_anykey();

// ƥץ졼Ⱥ
void	set_template(CImage& Im, RealCTemplate& TP, double xc, double yc);
void	set_template(CImage& Im, IntCTemplate& TP, double xc, double yc);

// 顼ФФʤ
void	CImage_set_quiet();
void	CImage_reset_quiet();

#endif	// _CIMAGE_H_
