//
// μưбդ(ver.1.3)
//	ʿ14ǯ615

// ǥ

#include <iostream>
#include <cmath>

using namespace std;

#include "Mat.h"
#include "Corresp_cls.h"
#include "homography.h"
#include "fundamental.h"
#include "eval_cnstr.h"

// ĺη׻
static double
residual_H(VecC Xa[], VecC Xb[], int N, Mat& H)
{
   double	J;

   J = 0.0;
   for (int i = 0; i < N; i++)
      J += calc_J_lambda_homo(H, Xa[i], Xb[i], 0);

   return J;
}

static double
residual_F(VecC Xa[], VecC Xb[], int N, Mat& F)
{
   double	J;

   J = 0.0;
   for (int i = 0; i < N; i++)
      J += calc_J_lambda_fund(F, Xa[i], Xb[i]);

   return J;
}

// ǥ
void
model_selection(VecC Xa[], VecC Xb[], int N,
		Mat& F, Mat& H, int *Fflag)
{
   double	JF, JH;
   double	eps2, Faic, Haic;

   JF = residual_F(Xa, Xb, N, F);
   JH = residual_H(Xa, Xb, N, H);

   eps2 = JF / (N - 7);
   Faic = JF + 2.0 * (3 * N + 7.0) * eps2;
   Haic = JH + 2.0 * (2 * N + 8.0) * eps2;

   cerr << "Faic " << Faic << ", Haic = " << Haic << endl;

   if (JH < ((3.0 + 12.0 / (N - 7.0)) * JF))
   {
      cerr << " *** H was selected!" << endl;
      *Fflag = 0;
   }
   else
   {
      cerr << " *** F was selected!" << endl;
      *Fflag = 1;
   }
}
