//
// μưбդ(ver.2.1)
//	ʿ14ǯ81

// RANSAC ˤù׻

#include	<iostream>
#include	<ctime>
#include	<cstdlib>


using namespace std;

#include	"Mat.h"
#include	"Tensor.h"

#include	"Corresp_cls.h"
#include	"CImage.h"
#include	"eval_cnstr.h"
#include	"geomtest.h"
#include	"fundamental.h"
#include	"decomp_test.h"
#include	"ransac_consts.h"
#include	"ransac_f.h"

// 襤饤ؿ
static inline double
sqr(double x)
{
   return x * x;
}

// μ
static void
set_seed(long *idum)
{
   long	t;

   t = (long)time(NULL);
   *idum = ((t >> 16) << 16) - t;
   if (*idum > 0)
      *idum = -(*idum);
}

// 8
static void
get_random_eight(long *idumptr, CrpPair cp[], int N, int indx[])
{
   int		p1, p2, p3, p4, p5, p6, p7, p8;

   // 1
   p1 = (int)(N * ran1(idumptr)) + 1;

   // 2
   do
   {
      p2 = (int)(N * ran1(idumptr)) + 1;
   }
   while (p1 == p2);

   // 3
   do
   {
      p3 = (int)(N * ran1(idumptr)) + 1;
   }
   while (p1 == p3 || p2 == p3);

   // 4
   do
   {
      p4 = (int)(N * ran1(idumptr)) + 1;
   }
   while (p1 == p4 || p2 == p4 || p3 == p4);

   // 5
   do
   {
      p5 = (int)(N * ran1(idumptr)) + 1;
   }
   while (p1 == p5 || p2 == p5 || p3 == p5 || p4 == p5);

   // 6
   do
   {
      p6 = (int)(N * ran1(idumptr)) + 1;
   }
   while (p1 == p6 || p2 == p6 || p3 == p6 || p4 == p6
	  || p5 == p6);

   // 7
   do
   {
      p7 = (int)(N * ran1(idumptr)) + 1;
   }
   while (p1 == p7 || p2 == p7 || p3 == p7 || p4 == p7
	  || p5 == p7 || p6 == p7);

   // 8
   do
   {
      p8 = (int)(N * ran1(idumptr)) + 1;
   }
   while (p1 == p8 || p2 == p8 || p3 == p8 || p4 == p8 
	  || p5 == p8 || p6 == p8 || p7 == p8);

   indx[0] = p1;
   indx[1] = p2;
   indx[2] = p3;
   indx[3] = p4;
   indx[4] = p5;
   indx[5] = p6;
   indx[6] = p7;
   indx[7] = p8;
}

// Ǿˡˤ F η׻
static int
calc_F_lsm(CrpPair cp[], int N, VecC Xa0[], VecC Xb0[], int idx[], Mat &F)
{
   VecC         Xa[8], Xb[8];

   for (int i = 0; i < 8; i++)
   {
      Xa[i] = Xa0[cp[idx[i]].a];
      Xb[i] = Xb0[cp[idx[i]].b];
   }

   if (calc_fundamental_ls(Xa, Xb, 8, F))
      return SUCCEEDED;

   return FAILED;
}

// ׻줿ù󤫤饵ݡȿ׻
static double
calc_support_F(Mat &F, CrpPair cp[], int N,
	       VecC Xa[], VecC Xb[], double dthd)
{
   VecC		x0, x1;
   double	J;
   double	sp;
   int		cs;

   // ĺη׻
   cs = 0;
   sp = 0.0;
   for (int i = 1; i <= N; i++)
   {
      x0 = Xa[cp[i].a];
      x1 = Xb[cp[i].b];
      J = calc_J_lambda_fund(F, x0, x1);
      if (J <= dthd)
      {
	 sp += cp[i].Plmd;
	 cs++;
      }
   }

   return sp;
}
      
// RANSAC ˤùη׻
double
ransac_fund(CrpPair cp[], int N,
	    VecC Xa[], int Na, VecC Xb[], int Nb,
	    int width, int height, double dthd, double fl, 
	    int MaxItr, Mat& Fm, int verbose)
{
   
   double	S, Sm;
   Mat		F;
   int		indx[F_MIN_PTS];
   int		count, ct;
   long		idum;

   if (verbose)
   {
      cerr << "[ransac fund]" << endl;
      cerr << "N = " << N << endl;
   }

   // μ
   set_seed(&idum);

   // ֤Τν
   Fm.clear(0.0);
   Sm = 0.0;
   count = ct = 0;

   if (N >= F_MIN_PTS)
   {
      while (count < MaxItr)
      {
	 count++;

	 // 8
	 get_random_eight(&idum, cp, N, indx);
	 if (verbose)
	 {
	    cerr << "indices: ("
		 << indx[0] << "," << indx[1] << "," << indx[2] << ","
		 << indx[3] << "," << indx[4] << "," << indx[5] << ","
		 << indx[6] << "," << indx[7] << ")" << endl;
	 }

	 // ƥ
	 if (!signtest(cp, Xa, Xb, indx, 8))
	 {
	    if (verbose)
	       cerr << "... rejected by sign test" << endl;
	    count--;
	    continue;
	 }

	 // եƥ
	 if (!affinetest(cp, Xa, Xb, indx, 8, width, height, fl))
	 {
	    if (verbose)
	       cerr << "... rejected by affine test" << endl;
	    count--;
	    continue;
	 }

	 // ùη׻
	 if (!calc_F_lsm(cp, N, Xa, Xb, indx, F))
	 {
	    if (verbose)
	       cerr << "*** indices are degenerated!" << endl;
	    count--;
	    continue;
	 }

	 // ʬǽȽ
	 if (!F_decomp_test(F))
	 {
	    if (verbose)
	       cerr << "*** matrix F cannot be decomposed!" << endl;
	    count--;
	    continue;
	 }
	       
	 if (verbose)
	    cerr << "F_ls = " << F << endl;

	 // ׻ùΥݡȤη׻
	 S = calc_support_F(F, cp, N, Xa, Xb, dthd);
	 if (verbose)
	    cerr << "S = " << S << endl;

	 // 
	 if (S > Sm)
	 {
	    if (verbose)
	    {
	       cerr << "[updated: " << count << "]" << endl;
	       cerr << "\tS = " << S << endl;
	       cerr << "\tF = " << F << endl;
	    }
	    Sm = S;
	    Fm = F;
	    ct = 0;
	 }
	 else
	 {
	    if (++ct >= COUNT_FOUND)
	    {
	       if (verbose)
		  cerr << "[ransac fund: I got it! (" << ct << ")]" << endl;
	       goto FOUND;
	    }
	 }
      }
   }
   if (verbose)
      cerr << "[ransac fund: I couldn't find!]" << endl;
   return -1;

  FOUND:
   return Sm;
}
